<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>code-review</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="code-review-tips">code-review-tips</h1>
    <h2 id="table-of-contents">Table of Contents</h2>
    <ol type="1">
      <li><a href="#introduction">Introduction</a></li>
      <li><a href="#why-review-code">Why Review Code?</a></li>
      <li><a href="#basics">Basics</a></li>
      <li><a href="#readability">Readability</a></li>
      <li><a href="#side-effects">Side Effects</a></li>
      <li><a href="#limits">Limits</a></li>
      <li><a href="#security">Security</a></li>
      <li><a href="#performance">Performance</a></li>
      <li><a href="#testing">Testing</a></li>
      <li><a href="#miscellaneous">Miscellaneous</a></li>
    </ol>
    <h2 id="introduction">Introduction</h2>
    <p>
      Code reviews can inspire dread in both reviewer and reviewee. Having your
      code analyzed can feel as invasive and uncomfortable. Even worse,
      reviewing other people’s code can feel like a painful and ambiguous
      exercise, searching for problems and not even knowing where to begin.
    </p>
    <p>
      This project aims to provide some solid tips for how to review the code
      that you and your team write. All examples are written in JavaScript, but
      the advice should be applicable to any project of any language. This is by
      no means an exhaustive list, but hopefully this will help you catch as
      many bugs as possible long before users ever see your feature.
    </p>
    <h2 id="why-review-code">Why Review Code?</h2>
    <p>
      Code reviews are a necessary part of the software engineering process
      because you alone can’t catch every problem in a piece of code you write.
      That’s ok though! Even the best basketball players in the world miss
      shots.
    </p>
    <p>
      Having others review our work ensures that we deliver the best product to
      users and with the least amount of errors. Make sure your team implements
      a code review process for new code that is introduced into your codebase.
      Find a process that works for you and your team. There’s no one size fits
      all. The important point is to do code reviews as regularly as possible.
    </p>
    <h2 id="basics">Basics</h2>
    <h3 id="code-reviews-should-be-as-automated-as-possible">
      Code reviews should be as automated as possible
    </h3>
    <p>
      Avoid discussing details that can be handled by a static analysis tool.
      Don’t argue about nuances such as code formatting and whether to use
      <code>let</code> or <code>var</code>. Having a formatter and linter can
      save your team a lot of time from reviews that your computer can do for
      you.
    </p>
    <h3 id="code-reviews-should-avoid-api-discussion">
      Code reviews should avoid API discussion
    </h3>
    <p>
      These discussions should happen before the code is even written. Don’t try
      to argue about the floor plan once you’ve poured the concrete foundation.
    </p>
    <h3 id="code-reviews-should-be-kind">Code reviews should be kind</h3>
    <p>
      It’s scary to have your code reviewed and it can bring about feelings of
      insecurity in even the most experienced developer. Be positive in your
      language and keep your teammates comfortable and secure in their work!
    </p>
    <h2 id="readability">Readability</h2>
    <h3 id="typos-should-be-corrected">Typos should be corrected</h3>
    <p>
      Avoid nitpicking as much as you can and save it for your linter, compiler,
      and formatter. When you can’t, such as in the case of typos, leave a kind
      comment suggesting a fix. It’s the little things that make a big
      difference sometimes!
    </p>
    <h3 id="variable-and-function-names-should-be-clear">
      Variable and function names should be clear
    </h3>
    <p>
      Naming is one of the hardest problems in computer science. We’ve all given
      names to variables, functions, and files that are confusing. Help your
      teammate out by suggesting a clearer name, if the one you’re reading
      doesn’t make sense.
    </p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="co">// This function could be better named as namesToUpperCase</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="kw">function</span> <span class="at">u</span>(names) <span class="op">{</span></a>
<a class="sourceLine" id="cb1-3" title="3">  <span class="co">// ...</span></a>
<a class="sourceLine" id="cb1-4" title="4"><span class="op">}</span></a></code></pre>
    </div>
    <h3 id="functions-should-be-short">Functions should be short</h3>
    <p>
      Functions should do one thing! Long functions usually mean that they are
      doing too much. Tell your teammate to split out the function into multiple
      different ones.
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="co">// This is both emailing clients and deciding which are active. Should be</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="co">// 2 different functions.</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="kw">function</span> <span class="at">emailClients</span>(clients) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-4" title="4">  <span class="va">clients</span>.<span class="at">forEach</span>((client) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-5" title="5">    <span class="kw">const</span> clientRecord <span class="op">=</span> <span class="va">database</span>.<span class="at">lookup</span>(client)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-6" title="6">    <span class="cf">if</span> (<span class="va">clientRecord</span>.<span class="at">isActive</span>()) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-7" title="7">      <span class="at">email</span>(client)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-8" title="8">    <span class="op">}</span></a>
<a class="sourceLine" id="cb2-9" title="9">  <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-10" title="10"><span class="op">}</span></a></code></pre>
    </div>
    <h3 id="files-should-be-cohesive-and-ideally-short">
      Files should be cohesive, and ideally short
    </h3>
    <p>
      Just like functions, a file should be about one thing. A file represents a
      module and a module should do one thing for your codebase.
    </p>
    <p>
      For example, if your module is called <code>fake-name-generator</code> it
      should just be responsible for creating fake names like “Keyser Söze”. If
      the <code>fake-name-generator</code> also includes a bunch of utility
      functions for querying a database of names, that should be in a separate
      module.
    </p>
    <p>
      There’s no rule for how long a file should be, but if it’s long like below
      <strong>and</strong> includes functions that don’t relate to one another,
      then it should probably be split apart.
    </p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="co">// Line 1</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="im">import</span> _ <span class="im">from</span> <span class="st">&quot;lodash&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="kw">function</span> <span class="at">generateFakeNames</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb3-4" title="4">  <span class="co">// ..</span></a>
<a class="sourceLine" id="cb3-5" title="5"><span class="op">}</span></a>
<a class="sourceLine" id="cb3-6" title="6"></a>
<a class="sourceLine" id="cb3-7" title="7"><span class="co">// Line 1128</span></a>
<a class="sourceLine" id="cb3-8" title="8"><span class="kw">function</span> <span class="at">queryRemoteDatabase</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb3-9" title="9">  <span class="co">// ...</span></a>
<a class="sourceLine" id="cb3-10" title="10"><span class="op">}</span></a></code></pre>
    </div>
    <h3 id="exported-functions-should-be-documented">
      Exported functions should be documented
    </h3>
    <p>
      If your function is intended to be used by other libraries, it helps to
      add documentation so users of it know what it does.
    </p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="co">// This needs documentation. What is this function for? How is it used?</span></a>
<a class="sourceLine" id="cb4-2" title="2"><span class="im">export</span> <span class="kw">function</span> <span class="at">networkMonitor</span>(graph<span class="op">,</span> duration<span class="op">,</span> failureCallback) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-3" title="3">  <span class="co">// ...</span></a>
<a class="sourceLine" id="cb4-4" title="4"><span class="op">}</span></a></code></pre>
    </div>
    <h3 id="complex-code-should-be-commented">
      Complex code should be commented
    </h3>
    <p>
      If you have named things well and the logic is still confusing, then it’s
      time for a comment.
    </p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">function</span> <span class="at">leftPad</span>(str<span class="op">,</span> len<span class="op">,</span> ch) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  str <span class="op">=</span> str <span class="op">+</span> <span class="st">&quot;&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-3" title="3">  len <span class="op">=</span> len <span class="op">-</span> <span class="va">str</span>.<span class="at">length</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-4" title="4"></a>
<a class="sourceLine" id="cb5-5" title="5">  <span class="cf">while</span> (<span class="kw">true</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-6" title="6">    <span class="co">// This needs a comment, why a bitwise and here?</span></a>
<a class="sourceLine" id="cb5-7" title="7">    <span class="cf">if</span> (len <span class="op">&amp;</span> <span class="dv">1</span>) pad <span class="op">+=</span> ch<span class="op">;</span></a>
<a class="sourceLine" id="cb5-8" title="8">    <span class="co">// This needs a comment, why a bit shift here?</span></a>
<a class="sourceLine" id="cb5-9" title="9">    len <span class="op">&gt;&gt;=</span> <span class="dv">1</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-10" title="10">    <span class="cf">if</span> (len) ch <span class="op">+=</span> ch<span class="op">;</span></a>
<a class="sourceLine" id="cb5-11" title="11">    <span class="cf">else</span> <span class="cf">break</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb5-13" title="13"></a>
<a class="sourceLine" id="cb5-14" title="14">  <span class="cf">return</span> pad <span class="op">+</span> str<span class="op">;</span></a>
<a class="sourceLine" id="cb5-15" title="15"><span class="op">}</span></a></code></pre>
    </div>
    <h2 id="side-effects">Side Effects</h2>
    <h3 id="functions-should-be-as-pure-as-possible">
      Functions should be as pure as possible
    </h3>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="co">// Global variable is referenced by the following function.</span></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="co">// If we had another function that used this name, now it&#39;d be an array and it</span></a>
<a class="sourceLine" id="cb6-3" title="3"><span class="co">// could break it. Instead it&#39;s better to pass in a name parameter</span></a>
<a class="sourceLine" id="cb6-4" title="4"><span class="kw">let</span> name <span class="op">=</span> <span class="st">&quot;Ryan McDermott&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb6-5" title="5"></a>
<a class="sourceLine" id="cb6-6" title="6"><span class="kw">function</span> <span class="at">splitIntoFirstAndLastName</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb6-7" title="7">  name <span class="op">=</span> <span class="va">name</span>.<span class="at">split</span>(<span class="st">&quot; &quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb6-8" title="8"><span class="op">}</span></a>
<a class="sourceLine" id="cb6-9" title="9"></a>
<a class="sourceLine" id="cb6-10" title="10"><span class="at">splitIntoFirstAndLastName</span>()<span class="op">;</span></a></code></pre>
    </div>
    <h3 id="io-functions-should-have-failure-cases-handled">
      I/O functions should have failure cases handled
    </h3>
    <p>Any function that does I/O should handle when something goes wrong</p>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">function</span> <span class="at">getIngredientsFromFile</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb7-2" title="2">  <span class="kw">const</span> onFulfilled <span class="op">=</span> (buffer) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb7-3" title="3">    <span class="kw">let</span> lines <span class="op">=</span> <span class="va">buffer</span>.<span class="at">split</span>(<span class="st">&quot;</span><span class="sc">\n</span><span class="st">&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-4" title="4">    <span class="cf">return</span> <span class="va">lines</span>.<span class="at">forEach</span>((line) <span class="kw">=&gt;</span> <span class="op">&lt;</span>Ingredient ingredient<span class="op">={</span>line<span class="op">}</span> /&gt;)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-5" title="5">  <span class="op">};</span></a>
<a class="sourceLine" id="cb7-6" title="6"></a>
<a class="sourceLine" id="cb7-7" title="7">  <span class="co">// What about when this rejected because of an error? What do we return?</span></a>
<a class="sourceLine" id="cb7-8" title="8">  <span class="cf">return</span> <span class="at">readFile</span>(<span class="st">&quot;./ingredients.txt&quot;</span>).<span class="at">then</span>(onFulfilled)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-9" title="9"><span class="op">}</span></a></code></pre>
    </div>
    <h2 id="limits">Limits</h2>
    <h3 id="null-cases-should-be-handled">Null cases should be handled</h3>
    <p>
      If you have a list component for example, all is well and good if you
      display a nice beautiful table that shows all its data. Your users love it
      and you get a promotion! But what happens when no data comes back? What do
      you show in the null case? Your code should be resilient to every case
      that can occur. If there’s something bad that can happen in your code,
      eventually it will happen.
    </p>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="kw">class</span> InventoryList <span class="op">{</span></a>
<a class="sourceLine" id="cb8-2" title="2">  <span class="at">constructor</span>(data) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-3" title="3">    <span class="kw">this</span>.<span class="at">data</span> <span class="op">=</span> data<span class="op">;</span></a>
<a class="sourceLine" id="cb8-4" title="4">  <span class="op">}</span></a>
<a class="sourceLine" id="cb8-5" title="5"></a>
<a class="sourceLine" id="cb8-6" title="6">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb8-7" title="7">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb8-8" title="8">      <span class="op">&lt;</span>table<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-9" title="9">        <span class="op">&lt;</span>tbody<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-10" title="10">          <span class="op">&lt;</span>tr<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-11" title="11">            <span class="op">&lt;</span>th<span class="op">&gt;</span>ID&lt;/th<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-12" title="12">            <span class="op">&lt;</span>th<span class="op">&gt;</span>Product&lt;/th<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-13" title="13">          &lt;/tr<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-14" title="14">          <span class="co">// We should show something for the null case here if there&#39;s // nothing</span></a>
<a class="sourceLine" id="cb8-15" title="15">          <span class="kw">in</span> the data inventory</a>
<a class="sourceLine" id="cb8-16" title="16">          <span class="op">{</span><span class="va">Object</span>.<span class="at">keys</span>(<span class="kw">this</span>.<span class="va">data</span>.<span class="at">inventory</span>).<span class="at">map</span>((itemId) <span class="kw">=&gt;</span> (</a>
<a class="sourceLine" id="cb8-17" title="17">            <span class="op">&lt;</span>tr key<span class="op">={</span>i<span class="op">}&gt;</span></a>
<a class="sourceLine" id="cb8-18" title="18">              <span class="op">&lt;</span>td<span class="op">&gt;{</span>itemId<span class="op">}</span>&lt;/td<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-19" title="19"></a>
<a class="sourceLine" id="cb8-20" title="20">              <span class="op">&lt;</span>td<span class="op">&gt;{</span><span class="kw">this</span>.<span class="va">state</span>.<span class="at">inventory</span>[itemId].<span class="at">product</span><span class="op">}</span>&lt;/td<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-21" title="21">            &lt;/tr<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-22" title="22">          ))<span class="op">}</span></a>
<a class="sourceLine" id="cb8-23" title="23">        &lt;/tbody<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-24" title="24">      &lt;/table<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb8-25" title="25">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb8-26" title="26">  <span class="op">}</span></a>
<a class="sourceLine" id="cb8-27" title="27"><span class="op">}</span></a></code></pre>
    </div>
    <h3 id="large-cases-should-be-handled">Large cases should be handled</h3>
    <p>
      In the list above, what would happen if 10,000 items came back from the
      inventory? In that case, you need some form of pagination or infinite
      scroll. Be sure to always assess the potential edge cases in terms of
      volume, especially when it comes to UI programming.
    </p>
    <h3 id="singular-cases-should-be-handled">
      Singular cases should be handled
    </h3>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="kw">class</span> MoneyDislay <span class="op">{</span></a>
<a class="sourceLine" id="cb9-2" title="2">  <span class="at">constructor</span>(amount) <span class="op">{</span></a>
<a class="sourceLine" id="cb9-3" title="3">    <span class="kw">this</span>.<span class="at">amount</span> <span class="op">=</span> amount<span class="op">;</span></a>
<a class="sourceLine" id="cb9-4" title="4">  <span class="op">}</span></a>
<a class="sourceLine" id="cb9-5" title="5"></a>
<a class="sourceLine" id="cb9-6" title="6">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb9-7" title="7">    <span class="co">// What happens if the user has 1 dollar? You can&#39;t say plural &quot;dollars&quot;</span></a>
<a class="sourceLine" id="cb9-8" title="8">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb9-9" title="9">      <span class="op">&lt;</span>div className<span class="op">=</span><span class="st">&quot;fancy-class&quot;</span><span class="op">&gt;</span></a>
<a class="sourceLine" id="cb9-10" title="10">        You have <span class="op">{</span><span class="kw">this</span>.<span class="at">amount</span><span class="op">}</span> dollars <span class="kw">in</span> your account</a>
<a class="sourceLine" id="cb9-11" title="11">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb9-12" title="12">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb9-13" title="13">  <span class="op">}</span></a>
<a class="sourceLine" id="cb9-14" title="14"><span class="op">}</span></a></code></pre>
    </div>
    <h3 id="user-input-should-be-limited">User input should be limited</h3>
    <p>
      Users can potentially input an unlimited amount of data to send to you.
      It’s important to set limits if a function takes any kind of user data in.
    </p>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="va">router</span>.<span class="at">route</span>(<span class="st">&quot;/message&quot;</span>).<span class="at">post</span>((req<span class="op">,</span> res) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb10-2" title="2">  <span class="kw">const</span> message <span class="op">=</span> <span class="va">req</span>.<span class="va">body</span>.<span class="at">content</span><span class="op">;</span></a>
<a class="sourceLine" id="cb10-3" title="3"></a>
<a class="sourceLine" id="cb10-4" title="4">  <span class="co">// What happens if the message is many megabytes of data? Do we want to store</span></a>
<a class="sourceLine" id="cb10-5" title="5">  <span class="co">// that in the database? We should set limits on the size.</span></a>
<a class="sourceLine" id="cb10-6" title="6">  <span class="va">db</span>.<span class="at">save</span>(message)<span class="op">;</span></a>
<a class="sourceLine" id="cb10-7" title="7"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h3 id="functions-should-handle-unexpected-user-input">
      Functions should handle unexpected user input
    </h3>
    <p>
      Users will always surprise you with the data they give you. Don’t expect
      that you will always get the right type of data or even any data in a
      request from a user.
      <a href="https://twitter.com/ryconoclast/status/885523459748487169"
        >And don’t rely on client-side validation alone</a
      >
    </p>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="va">router</span>.<span class="at">route</span>(<span class="st">&quot;/transfer-money&quot;</span>).<span class="at">post</span>((req<span class="op">,</span> res) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb11-2" title="2">  <span class="kw">const</span> amount <span class="op">=</span> <span class="va">req</span>.<span class="va">body</span>.<span class="at">amount</span><span class="op">;</span></a>
<a class="sourceLine" id="cb11-3" title="3">  <span class="kw">const</span> <span class="im">from</span> <span class="op">=</span> <span class="va">user</span>.<span class="at">id</span><span class="op">;</span></a>
<a class="sourceLine" id="cb11-4" title="4">  <span class="kw">const</span> to <span class="op">=</span> <span class="va">req</span>.<span class="va">body</span>.<span class="at">to</span><span class="op">;</span></a>
<a class="sourceLine" id="cb11-5" title="5"></a>
<a class="sourceLine" id="cb11-6" title="6">  <span class="co">// What happens if we got a string instead of a number as our amount? This</span></a>
<a class="sourceLine" id="cb11-7" title="7">  <span class="co">// function would fail</span></a>
<a class="sourceLine" id="cb11-8" title="8">  <span class="at">transferMoney</span>(<span class="im">from</span><span class="op">,</span> to<span class="op">,</span> amount)<span class="op">;</span></a>
<a class="sourceLine" id="cb11-9" title="9"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="security">Security</h2>
    <p>
      Data security is the most important aspect of your application. If users
      can’t trust you with their data, then you won’t have a business. There are
      numerous different types of security exploits that can plague an app,
      depending on the particular language and runtime environment. Below is a
      very small and incomplete list of common security problems. Don’t rely on
      this alone! Automate as much security review as you can on every commit,
      and perform routine security audits.
    </p>
    <h3 id="xss-should-not-be-possible">XSS should not be possible</h3>
    <p>
      Cross-site scripting (XSS) is one of the largest vectors for security
      attacks on a web application. It occurs when you take user data and
      include it in your page without first properly sanitizing it. This can
      cause your site to execute source code from remote pages.
    </p>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="kw">function</span> <span class="at">getBadges</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb12-2" title="2">  <span class="kw">let</span> badge <span class="op">=</span> <span class="va">document</span>.<span class="at">getElementsByClassName</span>(<span class="st">&quot;badge&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-3" title="3">  <span class="kw">let</span> nameQueryParam <span class="op">=</span> <span class="at">getQueryParams</span>(<span class="st">&quot;name&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb12-4" title="4"></a>
<a class="sourceLine" id="cb12-5" title="5">  <span class="co">/**</span></a>
<a class="sourceLine" id="cb12-6" title="6"><span class="co">   * What if nameQueryParam was `</span><span class="kw">&lt;script&gt;</span><span class="co">sendCookie(document.cookie)</span><span class="kw">&lt;/script&gt;</span><span class="co">`?</span></a>
<a class="sourceLine" id="cb12-7" title="7"><span class="co">   * If that was the query param, a malicious user could lure a user to click a</span></a>
<a class="sourceLine" id="cb12-8" title="8"><span class="co">   * link with that as the `name` query param, and have the user unknowingly</span></a>
<a class="sourceLine" id="cb12-9" title="9"><span class="co">   * send their data to a bad actor.</span></a>
<a class="sourceLine" id="cb12-10" title="10"><span class="co">   */</span></a>
<a class="sourceLine" id="cb12-11" title="11">  <span class="va">badge</span>.<span class="at">children</span>[<span class="dv">0</span>].<span class="at">innerHTML</span> <span class="op">=</span> nameQueryParam<span class="op">;</span></a>
<a class="sourceLine" id="cb12-12" title="12"><span class="op">}</span></a></code></pre>
    </div>
    <h3 id="personally-identifiable-information-pii-should-not-leak">
      Personally Identifiable Information (PII) should not leak
    </h3>
    <p>
      You bear an enormous weight of responsibility every time you take in user
      data. If you leak data in URLs, in analytics tracking to third parties, or
      even expose data to employees that shouldn’t have access, you greatly hurt
      your users and your business. Be careful with other people’s lives!
    </p>
    <div class="sourceCode" id="cb13">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb13-1" title="1"><span class="va">router</span>.<span class="at">route</span>(<span class="st">&quot;/bank-user-info&quot;</span>).<span class="at">get</span>((req<span class="op">,</span> res) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb13-2" title="2">  <span class="kw">const</span> name <span class="op">=</span> <span class="va">user</span>.<span class="at">name</span><span class="op">;</span></a>
<a class="sourceLine" id="cb13-3" title="3">  <span class="kw">const</span> id <span class="op">=</span> <span class="va">user</span>.<span class="at">id</span><span class="op">;</span></a>
<a class="sourceLine" id="cb13-4" title="4">  <span class="kw">const</span> socialSecurityNumber <span class="op">=</span> <span class="va">user</span>.<span class="at">ssn</span><span class="op">;</span></a>
<a class="sourceLine" id="cb13-5" title="5"></a>
<a class="sourceLine" id="cb13-6" title="6">  <span class="co">// There&#39;s no reason to send a socialSecurityNumber back in a query parameter</span></a>
<a class="sourceLine" id="cb13-7" title="7">  <span class="co">// This would be exposed in the URL and potentially to any middleman on the</span></a>
<a class="sourceLine" id="cb13-8" title="8">  <span class="co">// network watching internet traffic</span></a>
<a class="sourceLine" id="cb13-9" title="9">  <span class="va">res</span>.<span class="at">addToQueryParams</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb13-10" title="10">    name<span class="op">,</span></a>
<a class="sourceLine" id="cb13-11" title="11">    id<span class="op">,</span></a>
<a class="sourceLine" id="cb13-12" title="12">    socialSecurityNumber<span class="op">,</span></a>
<a class="sourceLine" id="cb13-13" title="13">  <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb13-14" title="14"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="performance">Performance</h2>
    <h3 id="functions-should-use-efficient-algorithms-and-data-structures">
      Functions should use efficient algorithms and data structures
    </h3>
    <p>
      This is different for every particular case, but use your best judgment to
      see if there are any ways to improve the efficiency of a piece of code.
      Your users will thank you for the faster speeds!
    </p>
    <div class="sourceCode" id="cb14">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb14-1" title="1"><span class="co">// If mentions was a hash data structure, you wouldn&#39;t need to iterate through</span></a>
<a class="sourceLine" id="cb14-2" title="2"><span class="co">// all mentions to find a user. You could simply return the presence of the</span></a>
<a class="sourceLine" id="cb14-3" title="3"><span class="co">// user key in the mentions hash</span></a>
<a class="sourceLine" id="cb14-4" title="4"><span class="kw">function</span> <span class="at">isUserMentionedInComments</span>(mentions<span class="op">,</span> user) <span class="op">{</span></a>
<a class="sourceLine" id="cb14-5" title="5">  <span class="kw">let</span> mentioned <span class="op">=</span> <span class="kw">false</span><span class="op">;</span></a>
<a class="sourceLine" id="cb14-6" title="6">  <span class="va">mentions</span>.<span class="at">forEach</span>((mention) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb14-7" title="7">    <span class="cf">if</span> (<span class="va">mention</span>.<span class="at">user</span> <span class="op">===</span> user) <span class="op">{</span></a>
<a class="sourceLine" id="cb14-8" title="8">      mentioned <span class="op">=</span> <span class="kw">true</span><span class="op">;</span></a>
<a class="sourceLine" id="cb14-9" title="9">    <span class="op">}</span></a>
<a class="sourceLine" id="cb14-10" title="10">  <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb14-11" title="11"></a>
<a class="sourceLine" id="cb14-12" title="12">  <span class="cf">return</span> mentioned<span class="op">;</span></a>
<a class="sourceLine" id="cb14-13" title="13"><span class="op">}</span></a></code></pre>
    </div>
    <h3 id="important-actions-should-be-logged">
      Important actions should be logged
    </h3>
    <p>
      Logging helps give metrics about performance and insight into user
      behavior. Not every action needs to be logged, but decide with your team
      what makes sense to keep track of for data analytics. And be sure that no
      personally identifiable information is exposed!
    </p>
    <div class="sourceCode" id="cb15">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb15-1" title="1"><span class="va">router</span>.<span class="at">route</span>(<span class="st">&quot;/request-ride&quot;</span>).<span class="at">post</span>((req<span class="op">,</span> res) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb15-2" title="2">  <span class="kw">const</span> currentLocation <span class="op">=</span> <span class="va">req</span>.<span class="va">body</span>.<span class="at">currentLocation</span><span class="op">;</span></a>
<a class="sourceLine" id="cb15-3" title="3">  <span class="kw">const</span> destination <span class="op">=</span> <span class="va">req</span>.<span class="va">body</span>.<span class="at">destination</span><span class="op">;</span></a>
<a class="sourceLine" id="cb15-4" title="4"></a>
<a class="sourceLine" id="cb15-5" title="5">  <span class="at">requestRide</span>(user<span class="op">,</span> currentLocation<span class="op">,</span> destination).<span class="at">then</span>((result) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb15-6" title="6">    <span class="co">// We should log before and after this block to get a metric for how long</span></a>
<a class="sourceLine" id="cb15-7" title="7">    <span class="co">// this task took, and potentially even what locations were involved in ride</span></a>
<a class="sourceLine" id="cb15-8" title="8">    <span class="co">// ...</span></a>
<a class="sourceLine" id="cb15-9" title="9">  <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-10" title="10"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="testing">Testing</h2>
    <h3 id="new-code-should-be-tested">New code should be tested</h3>
    <p>
      All new code should include a test, whether it fixes a bug, or is a new
      feature. If it’s a bug fix, it should have a test proving that the bug is
      fixed. And if it’s a new feature, then every component should be unit
      tested and there should be an integration test ensuring that the feature
      works with the rest of the system.
    </p>
    <h3 id="tests-should-actually-test-all-of-what-the-function-does">
      Tests should actually test all of what the function does
    </h3>
    <div class="sourceCode" id="cb16">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb16-1" title="1"><span class="kw">function</span> <span class="at">payEmployeeSalary</span>(employeeId<span class="op">,</span> amount<span class="op">,</span> callback) <span class="op">{</span></a>
<a class="sourceLine" id="cb16-2" title="2">  <span class="va">db</span>.<span class="at">get</span>(<span class="st">&quot;EMPLOYEES&quot;</span><span class="op">,</span> employeeId)</a>
<a class="sourceLine" id="cb16-3" title="3">    .<span class="at">then</span>((user) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb16-4" title="4">      <span class="cf">return</span> <span class="at">sendMoney</span>(user<span class="op">,</span> amount)<span class="op">;</span></a>
<a class="sourceLine" id="cb16-5" title="5">    <span class="op">}</span>)</a>
<a class="sourceLine" id="cb16-6" title="6">    .<span class="at">then</span>((res) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb16-7" title="7">      <span class="cf">if</span> (callback) <span class="op">{</span></a>
<a class="sourceLine" id="cb16-8" title="8">        <span class="at">callback</span>(res)<span class="op">;</span></a>
<a class="sourceLine" id="cb16-9" title="9">      <span class="op">}</span></a>
<a class="sourceLine" id="cb16-10" title="10"></a>
<a class="sourceLine" id="cb16-11" title="11">      <span class="cf">return</span> res<span class="op">;</span></a>
<a class="sourceLine" id="cb16-12" title="12">    <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb16-13" title="13"><span class="op">}</span></a>
<a class="sourceLine" id="cb16-14" title="14"></a>
<a class="sourceLine" id="cb16-15" title="15"><span class="kw">const</span> callback <span class="op">=</span> (res) <span class="kw">=&gt;</span> <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;called&quot;</span><span class="op">,</span> res)<span class="op">;</span></a>
<a class="sourceLine" id="cb16-16" title="16"><span class="kw">const</span> employee <span class="op">=</span> <span class="at">createFakeEmployee</span>(<span class="st">&quot;john jacob jingleheimer schmidt&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb16-17" title="17"><span class="kw">const</span> result <span class="op">=</span> <span class="at">payEmployeeSalary</span>(<span class="va">employee</span>.<span class="at">id</span><span class="op">,</span> <span class="dv">1000</span><span class="op">,</span> callback)<span class="op">;</span></a>
<a class="sourceLine" id="cb16-18" title="18"><span class="at">assert</span>(<span class="va">result</span>.<span class="at">status</span> <span class="op">===</span> <span class="va">enums</span>.<span class="at">SUCCESS</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb16-19" title="19"><span class="co">// What about the callback? That should be tested</span></a></code></pre>
    </div>
    <h3 id="tests-should-stress-edge-cases-and-limits-of-a-function">
      Tests should stress edge cases and limits of a function
    </h3>
    <div class="sourceCode" id="cb17">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb17-1" title="1"><span class="kw">function</span> <span class="at">dateAddDays</span>(dateTime<span class="op">,</span> day) <span class="op">{</span></a>
<a class="sourceLine" id="cb17-2" title="2">  <span class="co">// ...</span></a>
<a class="sourceLine" id="cb17-3" title="3"><span class="op">}</span></a>
<a class="sourceLine" id="cb17-4" title="4"></a>
<a class="sourceLine" id="cb17-5" title="5"><span class="kw">let</span> dateTime <span class="op">=</span> <span class="st">&quot;1/1/2017&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb17-6" title="6"><span class="kw">let</span> date1 <span class="op">=</span> <span class="at">dateAddDays</span>(dateTime<span class="op">,</span> <span class="dv">5</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb17-7" title="7"></a>
<a class="sourceLine" id="cb17-8" title="8"><span class="at">assert</span>(date1 <span class="op">===</span> <span class="st">&quot;1/6/2017&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb17-9" title="9"></a>
<a class="sourceLine" id="cb17-10" title="10"><span class="co">// What happens if we add negative days?</span></a>
<a class="sourceLine" id="cb17-11" title="11"><span class="co">// What happens if we add fractional days: 1.2, 8.7, etc.</span></a>
<a class="sourceLine" id="cb17-12" title="12"><span class="co">// What happens if we add 1 billion days?</span></a></code></pre>
    </div>
    <h2 id="miscellaneous">Miscellaneous</h2>
    <blockquote>
      <p><em>“Everything can be filed under miscellaneous”</em></p>
    </blockquote>
    <blockquote>
      <p>George Bernard Shaw</p>
    </blockquote>
    <h3 id="todo-comments-should-be-tracked">
      TODO comments should be tracked
    </h3>
    <p>
      TODO comments are great for letting you and your fellow engineers know
      that something needs to be fixed later. Sometimes you gotta ship code and
      wait to fix it later. But eventually you’ll have to clean it up! That’s
      why you should track it and give a corresponding ID from your issue
      tracking system so you can schedule it and keep track of where the problem
      is in your codebase.
    </p>
    <h3 id="commit-messages-should-be-clear-and-accurately-describe-new-code">
      Commit messages should be clear and accurately describe new code
    </h3>
    <p>
      We’ve all written commit messages like “Changed some crap”, “damn it”,
      “ugg one more to fix this stupid bug”. These are funny and satisfying, but
      not helpful when you’re up on a Saturday morning because you pushed code
      on a Friday night and can’t figure out what the bad code was doing when
      you <code>git blamed</code> the commit. Write commit messages that
      describe the code accurately, and include a ticket number from your issue
      tracking system if you have one. That will make searching through your
      commit log much easier.
    </p>
    <h3 id="the-code-should-do-what-its-supposed-to-do">
      The code should do what it’s supposed to do
    </h3>
    <p>
      This seems obvious, but most reviewers don’t have the time or take the
      time to manually test every user-facing change. It’s important to make
      sure the business logic of every change is as per design. It’s easy to
      forget that when you’re just looking for problems in the code!
    </p>
  </body>
</html>
